#include <stdio.h>
#include <string.h>

typedef struct {
		char	sta[5];
		char	net[3];
		char	cha[4];
		char	stime[32];
		char	etime[32];
	       } POD_Req_Cha;

typedef struct {
		char	sta[5];
		char	net[3];
		char	stime[32];
		char	etime[32];
	       } POD_Req_Sta;


/*  Global variables for the token list. */
int tokenc;
char **tokenv;

POD_Req_Cha	rc[100];
POD_Req_Sta	rs[100];
int		nb_req_cha = 0;
int		nb_req_sta = 0;


/*  Function declarations. */
int split_inline (char *line, char delim);
int split_copy  (char *line, char delim);
int reset_token (int *pargc, char ***pargv, int dup);
int push_token (int *pargc, char ***pargv, char *p, int dup);
char *strndup (char *p, int n);

/************************************************************************/
/*  main program:							*/
/************************************************************************/
main (int argc, char **argv)
{
    FILE 	*fp;
    char	 line[256], *p;
    char 	*file = "req";
    int 	dup = 0;
    int 	n;
    int	 	i;
    int 	Flag_Cha;
    int		Flag_Sta;
    char	syst[255];


    if (argc > 1) dup = atoi (*++argv);

    if ((fp=fopen(file,"r")) == NULL) {
	fprintf (stderr, "Error opening file %s\n");
	exit(1);
    }
    while (p=fgets(line,256,fp)) {
	file[255] = '\0';
	n = strlen(line);
	/* Remove the newline from the string. */
	if (n>0 && line[n-1]=='\n') line[--n] = '\0';
	/*printf ("Splitting the line, dup=%d\n", dup);*/

/*	This version splits the original line up into tokens.		*/
/*	It modifies the input line.					*/
	if (dup == 0) n = split_inline (line, '\t');

/*	This version splits the original line up into tokens.		*/
/*	It copies the the tokens, leaving the original line unmodified. */
	if (dup != 0) n = split_copy (line, '\t');

	if (n != 10) {
	    fprintf (stderr, "Error scanning line, expected 10, found %d\n",n);
	    fprintf (stderr, "Line:\t%s",line);
	    exit(1);
	}
	/*printf ("station  = '%s'\n", tokenv[0]);
	printf ("network  = '%s'\n", tokenv[1]);
	printf ("channel  = '%s'\n", tokenv[2]);
	printf ("location = '%s'\n", tokenv[3]);
	printf ("start    = '%s'\n", tokenv[8]);
	printf ("end      = '%s'\n", tokenv[9]);
	printf ("\n");*/

	/* Populating station array */
	Flag_Sta = 0;

	for (i=0;i<nb_req_sta;i++)
		{
		 if (	(!strcmp (rs[i].sta, tokenv[0])) &&
			(!strcmp (rs[i].net, tokenv[1]))	)
			{
			 Flag_Sta = 1;

			 if (strcmp (tokenv[8], rs[i].stime) < 0)
				strcpy (rs[i].stime, tokenv[8]);

			 if (strcmp (tokenv[9], rs[i].etime) > 0)
				strcpy (rs[i].etime, tokenv[9]);
			}
		}

	if (!Flag_Sta)
		{
		 strcpy (rs[nb_req_sta].sta, tokenv[0]);
		 strcpy (rs[nb_req_sta].net, tokenv[1]);

		 strcpy (rs[nb_req_sta].stime, tokenv[8]);
		 strcpy (rs[nb_req_sta].etime, tokenv[9]);

		 nb_req_sta++;
		}

	/* Populating channel array */
	Flag_Cha = 0;

	for (i=0;i<nb_req_cha;i++)
		{
		 if (	(!strcmp (rc[i].sta, tokenv[0])) &&
			(!strcmp (rc[i].net, tokenv[1])) &&
			(!strcmp (rc[i].cha, tokenv[2]))	)
			{
			 Flag_Cha = 1;

			 if (strcmp (tokenv[8], rc[i].stime) < 0)
				strcpy (rc[i].stime, tokenv[8]);

			 if (strcmp (tokenv[9], rc[i].etime) > 0)
				strcpy (rc[i].etime, tokenv[9]);
			}
		}

	if (!Flag_Cha)
		{
		 strcpy (rc[nb_req_cha].sta, tokenv[0]);
		 strcpy (rc[nb_req_cha].net, tokenv[1]);
		 strcpy (rc[nb_req_cha].cha, tokenv[2]);

		 strcpy (rc[nb_req_cha].stime, tokenv[8]);
		 strcpy (rc[nb_req_cha].etime, tokenv[9]);

		 nb_req_cha++;
		}

     reset_token (&tokenc, &tokenv, dup);
    }

    printf ("\n Generating station blockettes:\n\n");
    for (i=0;i<nb_req_sta;i++)
	{
	 strcpy (syst, "");
	 printf ("%5s %5s %.17s %.17s\n", rs[i].sta, rs[i].net, rs[i].stime, rs[i].etime);

	 sprintf (syst, "/data/09/stephane/DBMS_Query_Engine/Instrument_Responses/IR/Make_Blockettes/Make_Blockettes %s.%s %.17s %.17s s", rs[i].sta, rs[i].net, rs[i].stime, rs[i].etime);
printf ("\n[%s]\n", syst);

	 system (syst);
	}

    printf ("\n Generating channel blockettes:\n\n");
    for (i=0;i<nb_req_cha;i++)
	{
	 strcpy (syst, "");
	 printf ("%5s %5s %5s %.17s %.17s\n", rc[i].sta, rc[i].net, rc[i].cha, rc[i].stime, rc[i].etime);

	 sprintf (syst, "/data/09/stephane/DBMS_Query_Engine/Instrument_Responses/IR/Make_Blockettes/Make_Blockettes %s.%s:%s %.17s %.17s c", rc[i].sta, rc[i].net, rc[i].cha, rc[i].stime, rc[i].etime);

printf ("\n[%s]\n", syst);
	 system (syst);
	}

    printf ("\n");
    return (0);
}

/************************************************************************/
/*  Split functions:							*/
/*  The split functions will split a line containing 0 or more tokens	*/
/*  into an argc/argv style list of tokens.				*/
/*  Tokens are SEPARATED by the specified delimiter.			*/
/*  If there are NO characters in the line, there are no tokens.	*/
/*  If there are 2 adjacent delimeters (or adjacent delimiter and	*/
/*  string terminator), that represents a 0 length token.		*/
/************************************************************************/

/************************************************************************/
/*  split_inline:							*/
/*	Split line into tokens based on delimiter.			*/
/*	Push token onto list when start of token is seen.		*/
/*	Do not copy token, so token may be modified later.		*/
/*	Original line is modified.					*/
/************************************************************************/
int split_inline (char *line, char delim)
{
    char *p = line;
    int start_token = 1;
    int force_token = 0;
    for (p=line;;p++) {
	if (*p == 0) {
	    if (force_token) {
		push_token (&tokenc, &tokenv, p, 0);
	    }
	    return (tokenc);
	}
	if (start_token) {
	    push_token (&tokenc, &tokenv, p, 0);
	    start_token = 0;
	    force_token = 0;
	}
	if (*p == delim) {
	    *p = '\0';
	    start_token = 1;
	    force_token = 1;
	}
    }
}

/************************************************************************/
/*  split_copy:								*/
/*	Split line into tokens based on delimiter.			*/
/*	Push token onto list at end of token.				*/
/*	Copy token.  Do not modify original line.			*/
/************************************************************************/
int split_copy (char *line, char delim)
{
    char *p;
    char *s;
    char *str;
    int in_token = 0;
    for (p=line,s=line;;p++) {
	if (*p == 0) {
	    if (in_token) {
		str = strndup(s,p+1-s);
		str[p-s] = '\0';
		push_token (&tokenc, &tokenv, str, 0);
	    }
	    return (tokenc);
	}
	in_token = 1;
	if (*p == delim) {
	    str = strndup(s,p+1-s);
	    str[p-s] = '\0';
	    push_token (&tokenc, &tokenv, str, 0);
	    s = p+1;
	}
    }
}

/************************************************************************/
/*  General token routines.						*/
/************************************************************************/

/************************************************************************/
/*  push_token:								*/
/*	Push a token onto a token list.					*/
/*	Allocate additional space for the expanded token list.		*/
/*	Allocate space for actual token if dup flag is set.		*/
/************************************************************************/
int push_token (int *pargc, char ***pargv, char *p, int dup)
{
    int n = *pargc;
    char **argv = *pargv;
    argv = (n==0) ? (char **)malloc((n+1)*sizeof(char *)) :
		      (char **)realloc(argv,(n+1)*sizeof(char *));
    if (argv == NULL) {
	fprintf (stderr, "Error (re)allocing argv\n");
	exit(1);
    }
    argv[n++] = (dup) ? strdup(p) : p;
    *pargv = argv;
    *pargc = n;
    return (0);
}

/************************************************************************/
/*  reset_token:							*/
/*	Free the space for the tokenv array list.			*/
/*	Reset the token list variables.					*/
/*	Free actual tokens of dup variable is dup is set.		*/
/************************************************************************/
int reset_token (int *pargc, char ***pargv, int dup)
{
    if (dup) {
	int i;
	int argc = *pargc;
	char **argv = *pargv;
	for (i=0; i<argc; i++) {
	    free (argv[i]);
	}
    }
    if (*pargv) free (*pargv);
    *pargv = NULL;
    *pargc = 0;
}

char *strndup (char *p, int n)
{
    char *s, *t;
    s = (char *)malloc(n*sizeof(char));
    if (s == NULL) return (s);
    t = s;
    while (n-->0) *t++ = *p++;
    return s;
}
